import javax.imageio.*;
import java.io.*;
import java.awt.image.*;
import javax.swing.*;

public class SimpleWatermarker
{
    private static void creaMarchio() throws Exception
    {
        //Carico l'immagine
        BufferedImage gioconda=ImageIO.read(new File("gioconda.png"));
        //Carico la firma
        BufferedImage firma=ImageIO.read(new File("firma.png"));
        
        for (int x=0;x<firma.getWidth();x++)
            for (int y=0;y<firma.getHeight();y++)
            {
                //Recupero il pixel dell'immagine in posizione x,y
                int c=gioconda.getRGB(x,y);
                //pongo a zero l'ultimo bit del colore
                c=c&0xFFFFFFFE;
                //Recupero il pixel della firma in posizione x,y
                int cc=firma.getRGB(x,y);
                //Se il pixel della firma  nero pongo ad uno l'ultimo bit del colore
                if (cc==0xFF000000) c=c|0x00000001;
                //Imposto il pixel dell'immagine in posizione x,y
                gioconda.setRGB(x,y,c);
            }
        //Salvo l'immagine
        ImageIO.write(gioconda,"png",new File("giocondaMarchiataBene.png"));
    }
    
    private static void verificaMarchio() throws Exception
    {
        //Carico l'immagine
        BufferedImage gioconda=ImageIO.read(new File("giocondaMarchiataBene.png"));
        
        for (int x=0;x<gioconda.getWidth();x++)
            for (int y=0;y<gioconda.getHeight();y++)
            {
                //Recupero il pixel dell'immagine in posizione x,y
                int c=gioconda.getRGB(x,y);
                //Pongo a zero tutti i bit del colore eccetto l'ultimo
                c=c&0x00000001;
                //Se il colore  diverso da zero lo pongo a nero, altrimenti lo pongo a bianco
                c=(c!=0?0xFF000000:0xFFFFFFFF);
                //Imposto il pixel dell'immagine in posizione x,y
                gioconda.setRGB(x,y,c);
            }
        
        //Visualizzo il risultato in un frame
        JFrame f=new JFrame();
        f.getContentPane().add(new JScrollPane(new JLabel(new ImageIcon(gioconda))));
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setSize(500,500);
        f.setVisible(true);
    }
    
    public static void main(String a[]) throws Exception
    {
        verificaMarchio();
    }
}